//+------------------------------------------------------------------+
//|                                        Exp_VininI_Trend_LRMA.mq5 |
//|                             Copyright  2012,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"
//+------------------------------------------------+
//|    CXMA                          |
//+------------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------+
//|                          |
//+------------------------------------------------+
enum AlgMode
  {
   BREAKDOWN,  //  UpLevel  DnLevel 
   TWIST       //   
  };
//+------------------------------------------------+
//|                          |
//+------------------------------------------------+
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   //TrendFollow_2 Price 
  };
//+------------------------------------------------+
//|                          |
//+------------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+------------------------------------------------+
//|              |
//+------------------------------------------------+
input double MM=-0.1;             //      ,   -  
input int    StopLoss_=1000;      //  
input int    TakeProfit_=2000;    //  
input int    Deviation_=10;       //.    
input bool   BuyPosOpen=true;     //    
input bool   SellPosOpen=true;    //    
input bool   BuyPosClose=true;    //    
input bool   SellPosClose=true;   //    
input AlgMode Mode=BREAKDOWN;     //    
input uint SignalBar=1;           //     
input ENUM_TIMEFRAMES InpInd_Timeframe=PERIOD_H4; // 
//+------------------------------------------------+
//|    VininI_Trend_LRMA |
//+------------------------------------------------+
input int LRMAPeriod=13; // LRMA
input Smooth_Method MA_Method1=MODE_SMA; //  
input uint Length1=3; //                     
input int Phase1=15; //  ,
                     // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    

input uint MA_Step=10;  //    
input uint MA_Count=10;  //  

input Smooth_Method MA_Method2=MODE_JJMA; //  
input uint Length2=20; //  
input int Phase2=100;  //  ,
                       // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    

input Applied_price_ IPC=PRICE_CLOSE;// 
input int UpLevel=+10; //  ( 0/+100)
input int DnLevel=-10; //  ( -100/0)
//+------------------------------------------------+
//|    ChangeOfVolatility|
//+------------------------------------------------+
input uint MPeriod = 1;      //  
input uint Short=6;
input uint Long=100;
input uint MaxTrendLevel=60; //      ( 0/100)
//+------------------------------------------------+
//----          
int TimeShiftSec;
//----      
int InpInd_Handle1,InpInd_Handle2;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//                                                  | 
//+------------------------------------------------------------------+
#include <TradeAlgorithms.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----    VininI_Trend_LRMA
   InpInd_Handle1=iCustom(Symbol(),InpInd_Timeframe,"VininI_Trend_LRMA",LRMAPeriod,
                         MA_Method1,Length1,Phase1,MA_Step,MA_Count,MA_Method2,Length2,Phase2,IPC,UpLevel,DnLevel,0);
   if(InpInd_Handle1==INVALID_HANDLE) Print("      VininI_Trend_LRMA");
   
//----    ChangeOfVolatility
   InpInd_Handle2=iCustom(Symbol(),InpInd_Timeframe,"ChangeOfVolatility",MPeriod,Short,Long,UpLevel,MaxTrendLevel,0,0);
   if(InpInd_Handle2==INVALID_HANDLE) Print("      ChangeOfVolatility");

//----          
   TimeShiftSec=PeriodSeconds(InpInd_Timeframe);

//----    CXMA   SmoothAlgorithms.mqh
   CXMA XMA;

//----     
   int min_rates_1=int(LRMAPeriod); 
   min_rates_1+=XMA.GetStartBars(MA_Method1,Length1+MA_Step*(MA_Count-1),Phase1);
   min_rates_1+=XMA.GetStartBars(MA_Method2,Length2,Phase2);
//----  
   int min_rates_2=int(MPeriod+MathMax(Short,Long));
//----  
   min_rates_total=int(MathMax(min_rates_1,min_rates_2));
   min_rates_total+=int(3+SignalBar);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
   GlobalVariableDel_(Symbol());
//----
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//----       
   if(BarsCalculated(InpInd_Handle1)<min_rates_total) return;
   if(BarsCalculated(InpInd_Handle2)<min_rates_total) return;

//----       IsNewBar()  SeriesInfoInteger()  
   LoadHistory(TimeCurrent()-PeriodSeconds(InpInd_Timeframe)-1,Symbol(),InpInd_Timeframe);
   
   double Trend[1];

//----   
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;
   static CIsNewBar NB;

//+------------------------------------------------+
//|                    |
//+------------------------------------------------+
   if(!SignalBar || NB.IsNewBar(Symbol(),InpInd_Timeframe) || Recount) //     
     {
      //----   
      BUY_Open=false;
      SELL_Open=false;
      BUY_Close=false;
      SELL_Close=false;
      Recount=false;
      
      //----      
            if(CopyBuffer(InpInd_Handle2,0,SignalBar,1,Trend)<=0) {Recount=true; return;}

      switch(Mode)
        {
         case BREAKDOWN:
           {
            double Value[2];
            //----      
            if(CopyBuffer(InpInd_Handle1,0,SignalBar,2,Value)<=0) {Recount=true; return;}

            //----    
            if(Value[1]>UpLevel)
              {
               if(BuyPosOpen && Value[0]<=UpLevel&&Trend[0]>MaxTrendLevel) BUY_Open=true;
               if(SellPosClose) SELL_Close=true;
               UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }

            //----    
            if(Value[1]<DnLevel)
              {
               if(SellPosOpen && Value[0]>=DnLevel&&Trend[0]>MaxTrendLevel) SELL_Open=true;
               if(BuyPosClose) BUY_Close=true;
               DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }
           }
         break;

         case TWIST:
           {
            double Value[3];
            //----      
            if(CopyBuffer(InpInd_Handle1,0,SignalBar,3,Value)<=0) {Recount=true; return;}

            //----    
            if(Value[1]<Value[2])
              {
               if(BuyPosOpen && Value[0]>Value[1]&&Trend[0]>MaxTrendLevel) BUY_Open=true;
               if(SellPosClose) SELL_Close=true;
               UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }

            //----    
            if(Value[1]>Value[2])
              {
               if(SellPosOpen && Value[0]<Value[1]&&Trend[0]>MaxTrendLevel) SELL_Open=true;
               if(BuyPosClose) BUY_Close=true;
               DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
              }
           }
         break;
        }
     }

//+------------------------------------------------+
//|                              |
//+------------------------------------------------+
//----  
   BuyPositionClose(BUY_Close,Symbol(),Deviation_);

//----     
   SellPositionClose(SELL_Close,Symbol(),Deviation_);

//----  
   BuyPositionOpen(BUY_Open,Symbol(),UpSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);

//----  
   SellPositionOpen(SELL_Open,Symbol(),DnSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);
//----
  }
//+------------------------------------------------------------------+
